/*
 * Structures and types used to implement opendir/readdir/closedir
 * on Windows 95/NT.
 */

#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

/* Borland C++ */
#ifdef __BORLANDC__
#include <dir.h>
#endif /* __BORLANDC__ */

#if 0
#define API_EXPORT(type)    __declspec(dllexport) type __stdcall
#else
#define API_EXPORT(type)    type
#endif

/* struct dirent - same as Unix */
struct dirent {
    long d_ino;			/* inode (always 1 in WIN32) */
    off_t d_off;		/* offset to this dirent */
    unsigned short d_reclen;	/* length of d_name */
    char d_name[_MAX_FNAME+1];	/* filename (null terminated) */
};

/* typedef DIR - not the same as Unix */
typedef struct {
    long handle;		/* _findfirst/_findnext handle */
    short offset;		/* offset into directory */
    short finished;		/* 1 if there are not more files */
#ifdef __BORLANDC__
    struct ffblk       fileinfo;/* from _findfirst/_findnext */
#else
    struct _finddata_t fileinfo;/* from _findfirst/_findnext */
#endif /* __BORLANDC__ */

    char *dir;			/* the dir we are reading */
    struct dirent dent;		/* the dirent to return */
} DIR;

/* Function prototypes */
extern API_EXPORT(DIR *) opendir(const char *);
extern API_EXPORT(struct dirent *) readdir(DIR *);
extern API_EXPORT(int) closedir(DIR *);

#ifdef __BORLANDC__
#define _findfirst(x,y) findfirst((x),(y),0)
#define _findnext(x,y) findnext((y))
#endif /* __BORLANDC__ */
